# From the eland (without --multi) output, get the start position of the 25mer,
# and the match start position.
# Written by: Wendy Lee
# Written on: July 29th, 2008
# Last modified: Oct 17th, 2008
import sys
from commoncode import *

print '%s: version 1.1' % sys.argv[0]

try:
    import psyco
    psyco.full()
    print 'psyco is running'
except:
    print 'psyco is not running'
    pass

def getMatchesFromRDSFile(hitfile, outfile, cache):
        doCache = False
        cachePages = 0
        if cache > 0:
                doCache = True
                cachePages = int(cache)
        hitRDS = readDataset(hitfile, verbose = True, cache=doCache)
        if cachePages > 2000:
                hitRDS.setDBcache(cachePages)
 
        readlen = hitRDS.getReadSize()
        hitChromList = hitRDS.getChromosomes()
        hitChromList.sort()
        outStr = ""
        SNP_list = []
        start_dict = {}
        for achrom in hitChromList:
                if not achrom.startswith('chr'): continue
                print 'chromosome %s' % (achrom)
                hitDict = hitRDS.getReadsDict(fullChrom=True, chrom=achrom, withWeight=True, withMismatch=True)
                spliceDict = hitRDS.getSplicesDict(fullChrom=True, chrom=achrom, withMismatch=True, withPairID=True, readIDDict=True)
                spliceIDList = spliceDict.keys()
                for k in spliceIDList:
                        startpos =  spliceDict[k][0][0]
                        endpos = spliceDict[k][0][3]
                        sense = spliceDict[k][0][4]
                        mismatches = spliceDict[k][0][5]
                        if len(mismatches) < 1: 
                                content = []
                                key = achrom + ":" + str(startpos)
                                content.append(achrom)
                                content.append(startpos)
                                content.append(endpos)
                                SNP_list.append(content)
 
                for i in hitDict[achrom]:
                        start = i[0]
                        stop = start + readlen - 1
                        sense = i[1]
                        weight = i[2]
                        if len(i) > 3:
                                mismatches = i[3]
                                if len(mismatches) < 1: 
                                        content = []
                                        key = achrom + ":" + str(start)
                                        content.append(achrom)
                                        content.append(start)
                                        content.append(stop)
                                        SNP_list.append(content)

        SNP_list = sorted(SNP_list, key=lambda x:x[0])
	outStr = ""
        for k in SNP_list:
		for q in k:
			outStr += str(q) + "\t"	
		outStr += "\n"
	return outStr

def getColumnsFromElandFile(filename, unique):
        infile = file(filename, 'r')
        outStr = ""
        SNP_list = []
        start_dict = {}
        for line in infile:
                fileStr = str(line)
                l = fileStr.split()
                if len(l) < 2: continue
		if 'U0' not in l[2]: continue
                sz = len(l)
                if sz > 7:
                        if int(l[3]) == 1 and l[6].find("chr") != -1:       # only takes care of the reads that map to a chromosome 
                                content = []
                                start = int(l[7])
                                stop = start + 24
                                chrom_list = l[6].split(".")
                                chrom = chrom_list[0]
                                key = chrom + ":" + str(start)
                                if unique:
                                        if start_dict.has_key(key):
                                                start_dict[key] += 1
                                        else:
                                                start_dict[key] = 1 
                                                content.append(chrom)
                                                content.append(start)
                                                content.append(stop)
                                                SNP_list.append(content)
                                else:
                                        content.append(chrom)
                                        content.append(start)
                                        content.append(stop)
                                        SNP_list.append(content)
        SNP_list = sorted(SNP_list, key=lambda x:x[0])
	outStr = ""
        for k in SNP_list:
		for q in k:
			outStr += str(q) + "\t"	
		outStr += "\n"
	return outStr

#Main program for module testing
'''
if len(sys.argv) < 3:
        print 'usage: python2.5 %s mapfile outfile [-unique]' % sys.argv[0]
        sys.exit(1)
'''
if len(sys.argv) < 3:
        print 'usage: python2.5 %s samplerdsfile matches_outfile [-cache pages]' % sys.argv[0]
        sys.exit(1)

infile = sys.argv[1]
outfile = sys.argv[2]
cachePages = -1
if '-cache' in sys.argv:
        cachePages =  int(sys.argv[sys.argv.index('-cache') + 1])

MatchList =  getMatchesFromRDSFile(infile, outfile, cachePages)
f = open(outfile, 'w')
f.write(MatchList)
f.close()

