# From the eland (without --multi) output, get the start position of the 25mer, the mismatch position, the mismatch base.
# Written by: Wendy Lee
# Written on: July 19th, 2008
# Last modified: Oct 17th, 2008
import sys
from commoncode import *

try:
    import psyco
    psyco.full()
    print "psyco is running"
except:
    print "psyco is not running"    
    pass

# hitfile = rds file, outfile not too sure right now if we need it, cache is
# the number of pages that you want to have in cache
def getMismatchesFromRDS(hitfile, outfilename, cache):
	revcomp = {"A":"T", "T":"A", "G":"C", "C":"G", "N":"N"}
        doCache = False
        cachePages = 0 
        if cache > 0:
                doCache = True
                cachePages =  int(cache)
        hitRDS = readDataset(hitfile, verbose = True, cache=doCache)
        if cachePages > 2000:
                hitRDS.setDBcache(cachePages)

        readlen = hitRDS.getReadSize()
        hitChromList = hitRDS.getChromosomes()
        hitChromList.sort()
        SNP_list = []
        MATCH_list = []
        for achrom in hitChromList:
                if not achrom.startswith('chr'): continue
                print 'chromosome %s' % (achrom)
                hitDict = hitRDS.getReadsDict(fullChrom=True, chrom=achrom, withWeight=True, withMismatch=True, findallOptimize=False)
                spliceDict = hitRDS.getSplicesDict(fullChrom=True, chrom=achrom, withMismatch=True, withPairID=True, readIDDict=True)
                spliceIDList = spliceDict.keys()
                for k in spliceIDList:
                        startpos =  spliceDict[k][0][0]
                        lefthalf = spliceDict[k][0][1]
                        rightstart = spliceDict[k][0][2]
                        endpos = spliceDict[k][0][3]
                        sense = spliceDict[k][0][4]
                        mismatches = spliceDict[k][0][5]
                        if len(mismatches) < 1: continue
                        spMismatchList = mismatches.split(',')
                        content = []
                        for mismatch in spMismatchList:
                                change_len = len(mismatch)
                                if sense == '+':
                                        change_from = mismatch[0]
                                        change_base = mismatch[change_len-1]
                                        if change_base == 'N' or change_from == 'N': continue                                
                                        change_pos = int(mismatch[1:change_len-1])
                                elif sense == '-':
                                        change_from = revcomp[mismatch[0]]
                                        change_base = revcomp[mismatch[change_len-1]]
                                        if change_base == 'N' or change_from == 'N': continue
                                        change_pos = readlen - int(mismatch[1:change_len-1]) + 1
                                firsthalf = int(lefthalf)-int(startpos)+1
                                secondhalf = 0
                                if int(change_pos) <= int(firsthalf):
                                        change_at = startpos + change_pos - 1 
                                else:
                                        secondhalf = change_pos - firsthalf
                                        change_at = rightstart + secondhalf
#                                print "sense %s startpos %s changepos %s changeat %s firsthalf %s secondhalf %s rightstart %s lefthalf %s from %s to %s" % (sense, startpos, change_pos, change_at, firsthalf, secondhalf, rightstart, lefthalf, change_from, change_base)
                                content.append(achrom)
                                content.append(startpos)
                                content.append(change_at)
                                content.append(change_base)
                                content.append(change_from)
                                SNP_list.append(content)
                for i in hitDict[achrom]:
                        start = i[0]
                        sense = i[1]
                        weight = i[2]
                        if len(i) > 3:
                                mismatches = i[3]
                                if len(mismatches) < 1: continue
                                mismatchList = mismatches.split(',')
                                content = [] 
                                for mismatch in mismatchList:
                                        change_len = len(mismatch)
                                        if sense == '+':
                                                change_from = mismatch[0]
                                                change_base = mismatch[change_len-1]
                                                if change_base == 'N' or change_from == 'N': continue
                                                change_pos = int(mismatch[1:change_len-1])
                                        elif sense == '-':
                                                change_from = revcomp[mismatch[0]]
                                                change_base = revcomp[mismatch[change_len-1]]
                                                if change_base == 'N' or change_from == 'N': continue
                                                change_pos = readlen - int(mismatch[1:change_len-1]) + 1
                                        change_at = start + change_pos - 1
                                        content.append(achrom)
                                        content.append(start)
                                        content.append(change_at)
                                        content.append(change_base)
                                        content.append(change_from)
                                        SNP_list.append(content)
        return SNP_list

